#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main(int argc, char *argv[])
{
  FILE *fd;
  char line[4096];
  int nvars, npoints;
  int p, v, dataset, curr_dataset, standard_in, done_points;
  double *x_arr;
   
  done_points = 0;
  dataset = atoi(argv[1]);
  curr_dataset = 0;
  if(!strcmp(argv[2], "-")) fd = stdin;
  else fd = fopen(argv[2], "r");
  while(1) {
    while(fgets(line, sizeof(line), fd) ) {
      if(!strncmp(line, "Binary:", 7)) break;
      if(curr_dataset == dataset) {
        printf("# %s", line);
      }
      if(!strncmp(line, "No. of Data Rows :", 18)) {
        sscanf(line, "No. of Data Rows : %d", &npoints);
        done_points = 1;
      }
      if(!strncmp(line, "No. Variables:", 14)) {
        sscanf(line, "No. Variables: %d", &nvars);
      }
      if(!done_points && !strncmp(line, "No. Points:", 11)) {
        sscanf(line, "No. Points: %d", &npoints);
      }
    }
    x_arr = calloc(nvars * npoints, sizeof(double));
    for(p=0; p<npoints; p++) {
      for(v=0; v<nvars; v++) {
        fread(&x_arr[p * nvars + v], sizeof(double), 1, fd);
      }
    }
    if(curr_dataset == dataset) {
      for(v=0; v<nvars; v++) {
        for(p=0; p<npoints; p++) {
          printf("%20g %20g\n", x_arr[p*nvars], x_arr[p * nvars + v]);
        }
        printf("\n\n");
      }
    }
    free(x_arr);
    if(curr_dataset == dataset) break;
    curr_dataset++;
  }
  if(fd != stdin) fclose(fd);
  printf("npoints=%d\n", npoints);
  return EXIT_SUCCESS;
}
